# Basic

Branch: [edu-configuration-basic](https://gitlab.com/bytepen/edu/nixos/-/tree/edu-configuration-basic?ref_type=heads)

## What is this branch?

This branch is the most basic and standard configuration commonly seen with NixOS.
It is a minimally modified version of the config put out by `nixos-generate-config`.

I thought it would be a good idea to have this branch here just to explain a couple of things going on with very basic NixOS.

## configuration.nix

If you're here, I am assuming that you are very new to NixOS and want to learn more about the configuration.nix file, so I will use this to explain everything about that file.

If you're looking at a repository with a `configuration.nix` file, it is very likely they are not using Flakes, however, it is possible for a `configuration.nix` file to exist in a Flake repository if the person who set it up chooses to have it there.

In `configuration.nix`-based Configurations, this file serves as the source of truth, and it may look something like this:

```
{ config, pkgs, ... }:
{
  imports = [
    ./hardware-configuration.nix
  ];

  boot.loader.systemd-boot.enable = true;
  boot.loader.efi.canTouchEfiVariables = true;

  services.xserver.enable = true;

  system.stateVersion = "23.05";
}
```

That's all well and good, but what the hell does `boot.loader.systemd-boot.enable` mean, where does it come from, and how could you have known about it if it wasn't already in your configuration?

For answers to this, my favorite resource is [https://search.nixos.org](https://search.nixos.org).
This website allows you to easily find information about packages you can install with NixOS as well as Configuration Options, such as the `boot.loader.systemd-boot.enable` above.

You can visit [this link](https://search.nixos.org/options?channel=23.05&show=boot.loader.systemd-boot.enable&from=0&size=50&sort=relevance&type=packages&query=systemd-boot), which is searching for any options which contain the words `systemd-boot` and are available for the `23.05` channel.
Additionally, `boot.loader.systemd-boot.enable` has been expanded to see more information, which states that this option configures `Whether to enable the systemd-boot (formerly gummiboot) EFI boot manager` and the the default is `false`.

It also specifies that this option came from [this file in the nixpkgs repository](https://github.com/NixOS/nixpkgs/blob/nixos-23.05/nixos/modules/system/boot/loader/systemd-boot/systemd-boot.nix).
Don't worry too much about this at the moment.
The nixpkgs files are very intimidating at first (and for quite a while) and are also not strictly necessary to understand in order to make effective use of NixOS. If you did want to dip your toes, you could determine that this `enable` options comes from [here](https://github.com/NixOS/nixpkgs/blob/nixos-23.05/nixos/modules/system/boot/loader/systemd-boot/systemd-boot.nix#LL76C1-L83C7), which looks like this:

```
  options.boot.loader.systemd-boot = {
    enable = mkOption {
      default = false;

      type = types.bool;

      description = lib.mdDoc "Whether to enable the systemd-boot (formerly gummiboot) EFI boot manager";
    };
```

I also want to take a moment to point out two different ways that you could define options and use `boot.loader.systemd-boot.enable` and `boot.loader.efi.canTouchEfiVariables`.

As we have seen above, we can write the entire string on each line, however, you can also expand options in order to group ones with similar roots together.
In other words, both of the following definitions are identical and which you use is a personal preference as a case can be made for either.

```
boot.loader.systemd-boot.enable = true;
boot.loader.efi.canTouchEfiVariables = true;
```

```
boot.loader = {
  systemd-boot.enable = true;
  efi.canTouchEfiVariables = true;
};
```

I prefer how the second one looks, but it does make it more difficult if I need to expand at a different spot in the future as everything will need to get shifted around.

We can also use [search.nixos.org](https://search.nixos.org) to find packages we might want to install permanently with [environment.systemPackages](https://search.nixos.org/options?channel=23.05&show=environment.systemPackages&from=0&size=50&sort=relevance&type=packages&query=systemPackages) or temporarily with [nix-shell -p](../../commands/index.md).

With an understanding of how to use [search.nixos.org](https://search.nixos.org), you can get very far with your NixOS Configuration, since a very large portion of any NixOS Configuration consists of options pulled directly from there.


## hardware-configuration.nix

This is one of two files created by `nixos-generate-config`, and aims to contain only information which is unique to the hardware (to include disk partitions) of your current installation.

The note at the top of the file will state that it's automatically generated by `nixos-generate-config` and that you shouldn't modify it.
This may be true for certain configurations, but I found that I was very tempted to split the information in this file out into other files which made more sense for me as my Configuration got more complex.

The actual sentement of this note is "Realize that this information may or may not change over time, and that you should periodically check that data in the automatically generated file should be reflected in your NixOS Configuration."
For me, this means that from time to time, I will run `sudo nixos-generate-config --dir /tmp`, and compare `/tmp/configuration.nix` and `/tmp/hardware-configuration.nix` against my running Configuration to ensure nothing needs to be changed.
